/*
 * config.h
 *		 Copyright (C) 1995 Kazuhiko Yamamoto
 *	      Kazuhiko Yamamoto <kazu@is.aist-nara.ac.jp>
 */

/*
 * PROTOTYPE
 *      e.g. void test PROTO((a, b)) {};
 */

#ifdef __STDC__
#  define PROTO(list) list
#else
#  define PROTO(list) ()
#endif

#define private static
#define public  extern  


#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <unistd.h> /* not getwd but getcwd */

#include <sys/param.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/time.h>
#include <sys/file.h>

#include <signal.h>
typedef RETSIGTYPE (*sigtype)();

#include <errno.h>
#ifndef HAVE_STRERROR
extern char *sys_errlist[];
#define strerror(c)  sys_errlist[c]
#endif

#ifdef HAVE_MALLOC_H
#  include <malloc.h>
#else
#  ifndef STDC_HEADERS
   char *malloc(), *calloc();
#  endif
#endif
#include <utmp.h>
#include <pwd.h>
#include <time.h>
#include <fcntl.h>
#include <varargs.h>

#include <sys/socket.h>
#include <netinet/in.h>
#include <netinet/in_systm.h>
#include <netinet/ip.h>
#include <arpa/inet.h>	
#include <arpa/ftp.h>
#include <arpa/telnet.h>
#include <netdb.h>

#if STDC_HEADERS
#  include <string.h>
#  define memsetzero(ptr, size) memset((ptr), 0, (size)) 
#else
#  ifndef HAVE_STRCHR
#    define strchr index
#    define strrchr rindex
#  endif
   char *strchr (), *strrchr ();
#  ifdef HAVE_MEMCPY
#    define memsetzero(ptr, size) memset((ptr), 0, (size))
#  else
#    define memcpy(d, s, n) bcopy ((s), (d), (n))
#    define memmove(d, s, n) bcopy ((s), (d), (n))
#    define memsetzero(ptr, size) bzero((ptr), (size))
#  endif
#endif


#if HAVE_SYS_WAIT_H
#  include <sys/wait.h>
#endif
/* int wait(union wait *) */


#if HAVE_DIRENT_H
#  include <dirent.h>
#  define NAMLEN(dirent) strlen((dirent)->d_name)
#else
#  define dirent direct
#  define NAMLEN(dirent) (dirent)->d_namlen
#  if HAVE_SYS_NDIR_H
#    include <sys/ndir.h>
#  endif
#  if HAVE_SYS_DIR_H
#    include <sys/dir.h>
#  endif
#  if HAVE_NDIR_H
#    include <ndir.h>
#  endif
#endif

#ifdef HAVE_TERMIOS_H
#  include <termios.h>
#else
#  ifdef HAVE_TERMIO_H
#    include <termio.h>
#  else
#    ifdef HAVE_SYS_IOCTL_H
#      include <sys/ioctl.h>
#    endif
#    include <sgtty.h>
#  endif
#endif

#ifndef NCARGS
#include <limits.h>
#define        NCARGS  (ARG_MAX + (2 * PATH_MAX))
#endif

#define _PATH_TMPFILE   "/tmp/ftpXXXXXX"
#define _PATH_BSHELL    "/bin/sh"

#define RET 0
